﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class MaxTextScript : MonoBehaviour {

	private Text text;

	public float floatTime = 2;
	public float floatHeight = 2;

	private float startTime;
	private float startHeight;
	private float topHeight;

	// Use this for initialization
	void Start () {
		text = GetComponentInChildren<Text>();
		if (text == null) print (gameObject.name + " expected a text in its children!");
		startTime = Time.time;
		startHeight = transform.position.y;
		topHeight = startHeight + floatHeight;
	}
	
	// Update is called once per frame
	void Update () {
		if(GameManager.gameRunning()){
			if(Time.time >= startTime + floatTime) Destroy(gameObject);

			float newY = Mathf.SmoothStep(startHeight, topHeight, (Time.time - startTime) / floatTime);
			transform.position = new Vector3(transform.position.x, newY, transform.position.z);

			float newA = Mathf.SmoothStep(1, 0, (Time.time - startTime) / floatTime);
			text.color = new Color(text.color.r, text.color.g, text.color.b, newA);
		}
	}
}
