﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PickupDropper : MonoBehaviour {

	public float secsBetweenDrops = 15;
	public bool onlyOverPlatformsAboveLava = true;
	public float gapAboveLavaNeeded = 1;

	public List<Transform> pickups;

	private List<Transform> activePickups;

	private float nextDropTime;

	// Use this for initialization
	void Start () {
		nextDropTime = Time.time + secsBetweenDrops;
		activePickups = new List<Transform>();
	}
	
	// Update is called once per frame
	void Update () {
		if(GameManager.gameRunning()){
			if(Time.time > nextDropTime){
				//figure out what we're going to drop
				int pickupToDrop = Random.Range(0, pickups.Count);

				//now figure out where to drop it
				bool platformPicked = false;
				int platX = 0, platY = 0;
				while(!platformPicked){
					platX = Random.Range(0, PlatformsRiser.platformsX());
					platY = Random.Range(0, PlatformsRiser.platformsY());
					if(onlyOverPlatformsAboveLava && !PlatformsRiser.anyPlatformsAboveLava(gapAboveLavaNeeded)) platformPicked = true;
					if(onlyOverPlatformsAboveLava){
						if(PlatformsRiser.getPlatform(platX, platY).GetComponent<PlatformScript>().headAboveWater(gapAboveLavaNeeded)) platformPicked = true;
					}
				}
				Transform newPickup = Instantiate(pickups[pickupToDrop], new Vector3(PlatformsRiser.getPlatform(platX, platY).transform.position.x + PlatformsRiser.getHalfSize().x, transform.position.y, PlatformsRiser.getPlatform(platX, platY).transform.position.z + PlatformsRiser.getHalfSize().y), Quaternion.identity) as Transform;
				activePickups.Add(newPickup);
				//newPickup.parent = transform;

				nextDropTime += secsBetweenDrops;
			}
		}
	}

	void OnDestroy(){
		if(activePickups == null) return;
		foreach (Transform t in activePickups.ToArray()){
			if(t == null) {activePickups.Remove(t);
			} else {Destroy (t.gameObject);}
		}
	}
}
