using UnityEngine;
using System.Collections;

public class PlatformScript : MonoBehaviour {

	public float smoothTime = 0.5f;
	//private float riseVelocity;
	private float nextHeight;
	private float startHeight;
	private float riseStartTime;
	public bool isRising = false;

	public Transform box;

	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		if(GameManager.gameRunning()){
			if(isRising){
				//Vector3 newScale = new Vector3(transform.localScale.x, Mathf.SmoothDamp(transform.localScale.y, nextHeight, ref riseVelocity, smoothTime), transform.localScale.z);
				Vector3 newScale = new Vector3(transform.localScale.x, Mathf.SmoothStep(startHeight, nextHeight, (Time.time - riseStartTime) / smoothTime), transform.localScale.z);
				transform.localScale = newScale;
				//gameObject.renderer.material.SetTextureScale("_MainTex", new Vector2(1, newScale.y));

				if(Mathf.Approximately(newScale.y, nextHeight)) isRising = false;
			}
		}
	}

	public bool rising(){
		return isRising;
	}

	public bool setRise(float newHeight){
		if(newHeight > nextHeight){
			nextHeight = newHeight;
			riseStartTime = Time.time;
			startHeight = transform.localScale.y;
			isRising = true;
			return true;
		} else {
			return false;
		}
	}

	public bool headAboveWater(float gapNeeded = 0){
		//print ("box max y " + box.collider.bounds.max.y + " lava level " + LavaScript.lavaLevel() + " name: " + gameObject.name + " time " + Time.time);
		if(box.collider.bounds.max.y - gapNeeded > LavaScript.lavaLevel()){return true;} else {return false;}
	}
}
