using UnityEngine;
using System.Collections;

public class WallUpdater : MonoBehaviour {

	public Transform newSegment;
	public float segmentHeight;
	public float heightAdvance; //how far in advance it will instatiate the next segment, i.e. if height is 20 and advance is 5, segments will be created at 15, 35, etc.
	public float firstSegmentY = 0;

	public Transform trackedObject;
	public string trackedSearchString = "Player";
	private float nextSegment;

	// Use this for initialization
	void Start () {
		if(trackedObject == null) trackedObject = GameObject.Find(trackedSearchString).transform;
		nextSegment = firstSegmentY;
		Transform segment;
		segment = Instantiate(newSegment, new Vector3(transform.position.x, transform.position.y + firstSegmentY, transform.position.z), Quaternion.identity) as Transform;
		segment.SetParent(this.transform);
		nextSegment += segmentHeight;
	}
	
	// Update is called once per frame
	void Update () {
		if(GameManager.gameRunning()){
			if(trackedObject != null){
				if(trackedObject.position.y > nextSegment - heightAdvance){
					Transform segment = Instantiate(newSegment, new Vector3(transform.position.x, transform.position.y + nextSegment, transform.position.z), Quaternion.identity) as Transform;
					segment.SetParent(this.transform);
					nextSegment += segmentHeight;
				}
			}
		}
	}
}
